
{*******************************************************}
{                                                       }
{       Turbo Pascal Runtime Library                    }
{       CRT Interface Unit                              }
{                                                       }
{       Copyright (C) 1988,92 Borland International     }
{	Copyright (C) 1994 by Solar Designer           	}
{                                                       }
{*******************************************************}

unit DelaySnd;
{$R-,S-}
interface

procedure Sound(Hz: Word);
procedure NoSound;

procedure InitDelay;
procedure Delay(MS: Word);

implementation

procedure Sound; assembler;
asm
	MOV	BX,Hz
	MOV	AX,34DDH
	MOV	DX,0012H
	CMP	DX,BX
	JNC	@@2
	DIV	BX
	MOV	BX,AX
	IN	AL,61H
	TEST	AL,3
	JNZ	@@1
	OR	AL,3
	OUT	61H,AL
	MOV	AL,0B6H
	OUT	43H,AL
@@1:	MOV	AL,BL
	OUT	42H,AL
	MOV	AL,BH
	OUT	42H,AL
@@2:
end;

procedure NoSound; assembler;
asm
	IN	AL,61H
	AND	AL,0FCH
	OUT	61H,AL
end;

var
   DelayCnt        :Word;

procedure DelayLoop; assembler;
asm
@@1:	SUB	AX,1
	SBB	DX,0
	JC	@@2
	CMP	BL,ES:[DI]
	JE	@@1
@@2:
end;

procedure InitDelay; assembler;
asm
        MOV     ES,Seg0040
	MOV	DI,6Ch
	MOV	BL,ES:[DI]
@@2:	CMP	BL,ES:[DI]
	JE	@@2
	MOV	BL,ES:[DI]
	MOV	AX,-28
	CWD
	CALL	DelayLoop
	NOT	AX
	NOT	DX
	MOV	CX,55
	DIV	CX
	MOV	DelayCnt,AX
end;

procedure Delay; assembler;
asm
	MOV	CX,MS
	JCXZ	@@2
	MOV	ES,Seg0040
	XOR	DI,DI
	MOV	BL,ES:[DI]
@@1:	MOV	AX,DelayCnt
	XOR	DX,DX
	CALL	DelayLoop
	LOOP	@@1
@@2:
end;

end.


